/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2004 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */


#ifndef	_CPU_CONFIG_H_
#define	_CPU_CONFIG_H_


#ifndef _MACRO_ONLY
#include "cpu_insn.h"
#endif /* _MACRO_ONLY */

#ifndef _MACRO_ONLY
/* CC֐vg^Cv錾	*/
Inline void set_ipl(UINT8 ipl);
Inline UINT8 current_ipl(void);


/*
 *  {OSJ[lł͊ݐItOyIPL̑opčs
 *  ƂOƂ.{CPUł͏L𖞂Ă邽ߕs@\
 *  \tgEFAŕ₤Kv͂Ȃ.
 */

/*
 *  ݗDxxݒ
 */
Inline void set_ipl(UINT8 ipl)
{
	volatile UINT16 flg_reg;	/* ݒl쐬p	*/
	UINT16 flg_temp;			/* IPLl쐬p	*/


	/* IPLlȊÕtO擾	*/
	asm("	stc flg, $$[FB]", flg_reg);
	flg_reg &= (UINT16)0x00FF;

	/* ݒptOWX^l쐬	*/
	flg_temp = (UINT16)ipl;
	flg_temp <<= 12;
	flg_reg |= flg_temp;

	/* tOWX^ɐݒ	*/
	asm("	ldc $$[FB], flg", flg_reg);
}


/*
 *  ݗDxx擾
 */
Inline UINT8 current_ipl(void)
{
	volatile UINT16 flg_reg;	/* tOWX^擾p	*/


	/* IPLl̎擾(tOWX^bit12`bit14)	*/
	asm("	stc flg, $$[FB]", flg_reg);
	flg_reg >>= 12;

	return((UINT8)flg_reg);
}


/*Qƃvg^Cv*/
/*
 *  vZbTˑ̏(cpu_config.c)
 */
extern void	cpu_initialize(void);

/*
 *  vZbTˑ̏I(cpu_config.c)
 */
extern void	cpu_terminate(void);

/* TCB`}N	*/
#define DEFINE_CTXB(tnum) \
FP tcxb_pc[tnum]; \
VP tcxb_sp[tnum];

extern FP tcxb_pc[];
extern VP tcxb_sp[];

/*
 *  fBXpb`̃AZu֐vg^Cv錾
 *  (activate_r͋ʕ璼ڎQƂȂ߂ɂ͋LڂȂ)
 */
extern void  dispatch(void);
extern void  exit_and_dispatch(void);
extern void  start_dispatch(void);


/*
 *  ݃nh̏o̐}N
 *
 *  NC30WAłFB/SBȊO̓XNb`WX^ł邽
 *  őޔs. 
 */
/*
 *  ISR1}N
 *
 *  ISR1̑SĂ̏[ULqꍇ́Ccpu_defs.h ɂ閳}N
 *  uOMIT_ISR1_ENTRYv̒`Lɂ邱ƁD
 */
/* xN^e[ůOQƐ錾}N	*/
/*
 *  ݓԂƃxN^e[uʃt@CɐꍇɕKvƂȂD
 *  M16C̑SẴVXeŁCt@Co͂ƂȂĂ邽ߖ{}N
 *  gpꂽȂ\D
 *  ʃt@Co͂sꍇlCLڂ͎cĂD
 */
#if defined(OMIT_ISR1_ENTRY)
#define	ISR1_EXTERNAL(isr)		asm("	.glb	_" #isr )
#else	/* OMIT_ISR1_ENTRY	*/
#define	ISR1_EXTERNAL(isr)		asm("	.glb	_" #isr "_entry")
#endif	/* OMIT_ISR1_ENTRY	*/

/* xN^e[uo^V{}N	*/
#if defined(OMIT_ISR1_ENTRY)
#define	ISR1_SYMBOL(isr)		asm("	.lword	_" #isr )
#else	/* OMIT_ISR1_ENTRY	*/
#define	ISR1_SYMBOL(isr)		asm("	.lword	_" #isr "_entry")
#endif	/* OMIT_ISR1_ENTRY	*/

/* ̐}N	*/
#if defined(OMIT_ISR1_ENTRY)
#define ISR1_ENTRY(isr)
#else	/* OMIT_ISR1_ENTRY	*/
#define ISR1_ENTRY(isr)\
asm("	.glb _" #isr "					");\
asm("	.section program, code, align	");\
asm("_" #isr "_entry:					");\
asm("	pushm	r0,r1,r2,r3,a0,a1	; XNb`WX^^XNX^bN֑ޔ");\
asm("	jsr	_" #isr );\
asm("	popm	r0,r1,r2,r3,a0,a1	; XNb`WX^^XNX^bN畜A");\
asm("	reit	");
#endif	/* OMIT_ISR1_ENTRY	*/


/*
 *  ISR2}N
 */
/* xN^e[ůOQƐ錾}N	*/
/*
 *  ݓԂƃxN^e[uʃt@CɐꍇɕKvƂȂD
 *  M16C̑SẴVXeŁCt@Co͂ƂȂĂ邽ߖ{}N
 *  gpꂽȂ\D
 *  ʃt@Co͂sꍇlCLڂ͎cĂD
 */
#define	ISR2_EXTERNAL(isr)		asm("	.glb	_" #isr "_entry")

/* xN^e[uo^V{}N	*/
#define	ISR2_SYMBOL(isr)		asm("	.lword	_" #isr "_entry")

/* ̐}N	*/
#define ISR2_ENTRY(isr, isrid)\
asm("	.glb _runisr						");\
asm("	.glb _ISRMain" #isr "				");\
asm("	.glb _interrupt						");\
asm("	.section program, code, align		");\
asm("_" #isr "_entry:						");\
asm("	pushm	r0,r1,r2,r3,a0,a1		; XNb`WX^ޔ");\
asm("	mov.b	#_ISRMain" #isr ">>010h, a1		; ISȐʃAhXa1");\
asm("	mov.w	#_ISRMain" #isr "& 0ffffh, a0	; ISR̉ʃAhXa0");\
asm("	mov.b:s	_runisr, r0l			; sIDێ");\
asm("	mov.b	#" #isrid ", _runisr	; sIDݒ");\
asm("	jmp.a	_interrupt				; ݏ[`㔼	");


/*
 *  gpݐ}N
 */

/* xN^e[ůOQƐ錾}N	*/
#define	UNUSED_INT_EXTERNAL()	asm("	.glb	_unused_interrupt")

/* xN^e[uo^V{}N	*/
#define	UNUSED_INT_SYMBOL()		asm("	.lword	_unused_interrupt")


/*
 *  tbN[`NULLV{}N
 */
#define	NULL_ERRORHOOK \
asm(".glb	$ErrorHook");\
asm("$ErrorHook .equ 0");

#define	NULL_STARTUPHOOK \
asm(".glb	_StartupHook"); \
asm("_StartupHook .equ 0");

#define	NULL_SHUTDOWNHOOK \
asm(".glb	$ShutdownHook"); \
asm("$ShutdownHook .equ 0");

#define	NULL_PRETASKHOOK \
asm(".glb	_PreTaskHook"); \
asm("_PreTaskHook .equ 0");

#define	NULL_POSTTASKHOOK \
asm(".glb	_PostTaskHook"); \
asm("_PostTaskHook .equ 0");


#endif /* _MACRO_ONLY */
#endif	/* _CPU_CONFIG_H_	*/

