/*
 *  TECS Sample component for TOPPERS Automotive Kernel 1
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2012 by TOPPERS Project TECS-WG
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tSample.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernelTask context: task
 *   StatusType     schedule( );
 *   void           enableAllInterrupts( );
 *   void           disableAllInterrupts( );
 *   void           resumeAllInterrupts( );
 *   void           suspendAllInterrupts( );
 *   void           resumeOsInterrupts( );
 *   void           suspendOsinterrupts( );
 *   AppModeType    getActiveApplicationMode( );
 *   StatusType     terminate( );
 *   void           shutdownOs( StatusType ercd );
 * call port : cTask1  signature: sTask context: task
 *   StatusType     cTask1_activate( );
 *   StatusType     cTask1_chain( );
 *   StatusType     cTask1_getId( TaskRefType p_tskid );
 *   StatusType     cTask1_getState( TaskStateRefType p_state );
 * call port : cTask2  signature: sTask context: task
 *   StatusType     cTask2_activate( );
 *   StatusType     cTask2_chain( );
 *   StatusType     cTask2_getId( TaskRefType p_tskid );
 *   StatusType     cTask2_getState( TaskStateRefType p_state );
 * call port : cTask3  signature: sTask context: task
 *   StatusType     cTask3_activate( );
 *   StatusType     cTask3_chain( );
 *   StatusType     cTask3_getId( TaskRefType p_tskid );
 *   StatusType     cTask3_getState( TaskStateRefType p_state );
 * call port : cSerial  signature: sSerial context: task
 *   void           cSerial_initialize( );
 *   void           cSerial_terminate( );
 *   void           cSerial_sendString( const UINT8* str );
 *   void           cSerial_sendIntString( const UINT8* str );
 *   void           cSerial_receivePollingChar( UINT8* character );
 * call port : cSysTimer  signature: sSysTimer context: task
 *   void           cSysTimer_initialize( );
 *   void           cSysTimer_terminate( );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ #_PAC_# */
#include "tSample_tecsgen.h"
#include "kernel_id.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eTask1Body
 * entry port: eTask1Body
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTask1Body_main
 * name:         eTask1Body_main
 * global_name:  tSample_eTask1Body_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTask1Body_main()
{
	cSerial_sendString( (const UINT8 *)"task1 ACTIVATE\r\n" );

	cSerial_sendString( (const UINT8 *)"task1 ActivateTask(task2)\r\n" );
	cTask2_activate();

	cSerial_sendString( (const UINT8 *)"task1 TERMINATE\r\n" );
}

/* #[<ENTRY_PORT>]# eTask2Body
 * entry port: eTask2Body
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTask2Body_main
 * name:         eTask2Body_main
 * global_name:  tSample_eTask2Body_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTask2Body_main()
{
	cSerial_sendString( (const UINT8 *)"task2 ACTIVATE\r\n" );

	cSerial_sendString( (const UINT8 *)"task2 ActivateTask(task3)\r\n" );
	cTask3_activate();

	cSerial_sendString( (const UINT8 *)"task2 TERMINATE\r\n" );
}

/* #[<ENTRY_PORT>]# eTask3Body
 * entry port: eTask3Body
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTask3Body_main
 * name:         eTask3Body_main
 * global_name:  tSample_eTask3Body_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTask3Body_main()
{
	cSerial_sendString( (const UINT8 *)"task3 ACTIVATE\r\n" );

	cSerial_sendString( (const UINT8 *)"task3 ActivateTask(task1)\r\n" );
	cTask1_activate();

	cSerial_sendString( (const UINT8 *)"task3 TERMINATE\r\n" );
}

/* #[<ENTRY_PORT>]# eAlm1Body
 * entry port: eAlm1Body
 * signature:  sHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eAlm1Body_main
 * name:         eAlm1Body_main
 * global_name:  tSample_eAlm1Body_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eAlm1Body_main()
{
	cSerial_sendIntString( (const UINT8 *)"ALARM COMP\r\n" );
}

/* #[<ENTRY_PORT>]# eStartupHookBody
 * entry port: eStartupHookBody
 * signature:  sHookBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eStartupHookBody_main
 * name:         eStartupHookBody_main
 * global_name:  tSample_eStartupHookBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eStartupHookBody_main()
{
	cSerial_initialize();		/* VAIOW[		*/
	
	cSysTimer_initialize();		/* VXe^C}N				*/
	
	/* NOo	*/
	cSerial_sendIntString( (const UINT8 *)
					"\r\nTOPPERS Automotive Kernel Release 1.0" );
#if defined( TARGET_NAME )
	cSerial_sendIntString( (const UINT8 *)" for " );
	cSerial_sendIntString( TARGET_NAME );
#endif	/* TARGET_NAME	*/
	cSerial_sendIntString( (const UINT8 *)
					"\r\nSample System StartUp\r\n\r\n" );
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/

#include <tKernel_inline.h>
 
int main(void)
{
	ePreKernel_startOs(AppMode1);
	
	while( 1 );
}
