/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2011 by TOPPERS Project
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tSerial.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tSerial_template.c => src/tSerial.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * rx_char          UINT8            VAR_rx_char     
 * rx_flag          BOOL             VAR_rx_flag     
 *
 * Ăь֐ #_TCPF_#
 * call port : cKernelTask  signature: sKernelTask context: task
 *   StatusType     cKernelTask_schedule( );
 *   void           cKernelTask_enableAllInterrupts( );
 *   void           cKernelTask_disableAllInterrupts( );
 *   void           cKernelTask_resumeAllInterrupts( );
 *   void           cKernelTask_suspendAllInterrupts( );
 *   void           cKernelTask_resumeOsInterrupts( );
 *   void           cKernelTask_suspendOsinterrupts( );
 *   AppModeType    cKernelTask_getActiveApplicationMode( );
 *   void           cKernelTask_shutdownOs( StatusType ercd );
 * call port : cKernelISR1  signature: sKernelISR1 context: task
 *   void           cKernelISR1_enableAllInterrupts( );
 *   void           cKernelISR1_disableAllInterrupts( );
 *   void           cKernelISR1_resumeAllInterrupts( );
 *   void           cKernelISR1_suspendAllInterrupts( );
 *   void           cKernelISR1_resumeOsInterrupts( );
 *   void           cKernelISR1_suspendOsinterrupts( );
 * call port : cHwSerial  signature: sHwSerial context: task
 *   void           cHwSerial_initialize( );
 *   void           cHwSerial_terminate( );
 * call port : cinHwSerial  signature: sinHwSerial context: task
 *   void           cinHwSerial_putChar( UINT8 character );
 * call port : cString  signature: sString context: task
 *   void           cString_long2Decimal( UINT8* dst, UINT32 src );
 *   void           cString_short2Decimal( UINT8* dst, UINT16 src );
 *   void           cString_byte2Decimal( UINT8* dst, UINT8 src );
 *   void           cString_long2Hex( UINT8* dst, UINT32 src );
 *   void           cString_short2Hex( UINT8* dst, UINT16 src );
 *   void           cString_byte2Hex( UINT8* dst, UINT8 src );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tSerial_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSerial
 * entry port: eSerial
 * signature:  sSerial
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSerial_initialize
 * name:         eSerial_initialize
 * global_name:  tSerial_eSerial_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSerial_initialize()
{
	/*
	 *  MtO
	 */
	VAR_rx_flag = FALSE;

	/*
	 *  ˑs
	 */
	cHwSerial_initialize();
}

/* #[<ENTRY_FUNC>]# eSerial_terminate
 * name:         eSerial_terminate
 * global_name:  tSerial_eSerial_terminate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSerial_terminate()
{
	cHwSerial_terminate();
}

/* #[<ENTRY_FUNC>]# eSerial_sendString
 * name:         eSerial_sendString
 * global_name:  tSerial_eSerial_sendString
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSerial_sendString(const UINT8* str)
{
	/*
	 *  ݋֎~ԂɂāCݒ񑗐Ms
	 */
	cKernelTask_suspendAllInterrupts();
	eSerial_sendIntString( str );
	cKernelTask_resumeAllInterrupts();
}

/* #[<ENTRY_FUNC>]# eSerial_sendIntString
 * name:         eSerial_sendIntString
 * global_name:  tSerial_eSerial_sendIntString
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSerial_sendIntString(const UINT8* str)
{
	/*
	 *  ˑo͏ɂđSf[^𑗐M
	 */
	while( *str != '\0' ){
		cinHwSerial_putChar( *str );
		str++;
	}
}

/* #[<ENTRY_FUNC>]# eSerial_receivePollingChar
 * name:         eSerial_receivePollingChar
 * global_name:  tSerial_eSerial_receivePollingChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSerial_receivePollingChar(UINT8* character)
{
	if( VAR_rx_flag == TRUE ){
	/*
	 *  ݋֎~ɂĎMf[^擾EtONA
	 */
		cKernelTask_suspendAllInterrupts();
		*character = VAR_rx_char;
		VAR_rx_flag = FALSE;
		cKernelTask_resumeAllInterrupts();
	}
	else{
	/*
	 *  Mf[^Ȃꍇ'\0'Ԃ
	 */
		*character = '\0';
	}
}

/* #[<ENTRY_PORT>]# eiHwSerial
 * entry port: eiHwSerial
 * signature:  siHwSerial
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiHwSerial_receiveChar
 * name:         eiHwSerial_receiveChar
 * global_name:  tSerial_eiHwSerial_receiveChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eiHwSerial_receiveChar(UINT8 character)
{
	/*
	 *  ݋֎~ɂĎMf[^ێEtONA
	 */
	cKernelISR1_suspendAllInterrupts();
	VAR_rx_char = character;
	VAR_rx_flag = TRUE;
	cKernelISR1_resumeAllInterrupts();
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
