/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2011 by TOPPERS Project
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tString.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tString_template.c => src/tString.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * reserve          UINT8            ATTR_reserve    
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tString_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eString
 * entry port: eString
 * signature:  sString
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eString_long2Decimal
 * name:         eString_long2Decimal
 * global_name:  tString_eString_long2Decimal
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_long2Decimal(UINT8* dst, UINT32 src)
{
	UINT32	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst-- = (UINT8)( ( src % 10 ) + '0' );
	} while( ( src /= 10 ) != 0 );
}

/* #[<ENTRY_FUNC>]# eString_short2Decimal
 * name:         eString_short2Decimal
 * global_name:  tString_eString_short2Decimal
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_short2Decimal(UINT8* dst, UINT16 src)
{
	UINT16	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst-- = (UINT8)( ( src % 10 ) + '0' );
	} while( ( src /= 10 ) != 0 );
}

/* #[<ENTRY_FUNC>]# eString_byte2Decimal
 * name:         eString_byte2Decimal
 * global_name:  tString_eString_byte2Decimal
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_byte2Decimal(UINT8* dst, UINT8 src)
{
	UINT8	temp;	/* Zope|	*/

	/*
	 *  \Zo
	 */
	temp = src;
	while( ( temp /= 10 ) != 0 ){
		dst++;
	}
	
	dst[1] = '\0';	/* I[R[hݒ	*/

	/*
	 *  ɕϊ
	 */
	do{
		*dst-- = (UINT8)( ( src % 10 ) + '0' );
	} while( ( src /= 10 ) != 0 );
}

/* #[<ENTRY_FUNC>]# eString_long2Hex
 * name:         eString_long2Hex
 * global_name:  tString_eString_long2Hex
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_long2Hex(UINT8* dst, UINT32 src)
{
	UINT8	mod;
	INT8	idx = 8;
	/*
	 *  80l߂16iɕϊ
	 */

	dst[idx--] = '\0';	/* I[R[hݒ	*/

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT32)0x0000000f );
		if( mod < 10 ){
			dst[idx--] = (UINT8)( mod + '0' );
		}
		else{
			dst[idx--] = (UINT8)( ( mod - 10 ) + 'A' );
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx--] = (UINT8)'0';
	}
}

/* #[<ENTRY_FUNC>]# eString_short2Hex
 * name:         eString_short2Hex
 * global_name:  tString_eString_short2Hex
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_short2Hex(UINT8* dst, UINT16 src)
{
	UINT8	mod;
	INT8	idx = 4;
	/*
	 *  40l߂16iɕϊ
	 */

	dst[idx--] = '\0';	/* I[R[hݒ	*/

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT16)0x000f );
		if( mod < 10 ){
			dst[idx--] = (UINT8)( mod + '0' );
		}
		else{
			dst[idx--] = (UINT8)( ( mod - 10 ) + 'A' );
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx--] = (UINT8)'0';
	}
}

/* #[<ENTRY_FUNC>]# eString_byte2Hex
 * name:         eString_byte2Hex
 * global_name:  tString_eString_byte2Hex
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eString_byte2Hex(UINT8* dst, UINT8 src)
{
	UINT8	mod;
	INT8	idx = 2;
	/*
	 *  20l߂16iɕϊ
	 */

	dst[idx--] = '\0';	/* I[R[hݒ	*/

	/*
	 *  16iɕϊ
	 */
	do{
		mod = (UINT8)( src & (UINT8)0x0f );
		if( mod < 10 ){
			dst[idx--] = (UINT8)( mod + '0' );
		}
		else{
			dst[idx--] = (UINT8)( ( mod - 10 ) + 'A' );
		}
	} while( ( src >>= 4 ) != 0 );

	/*
	 *  č0l
	 */
	while( idx >= 0 ){
		dst[idx--] = (UINT8)'0';
	}
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
