/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2008-2011 by TOPPERS Project
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *  
 *  $Id: tSysTimer.c 1481 2011-06-09 16:37:43Z witz-ukai $
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tSysTimer_template.c => src/tSysTimer.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * Ăь֐ #_TCPF_#
 * call port : cKernelTask  signature: sKernelTask context: task
 *   StatusType     cKernelTask_schedule( );
 *   void           cKernelTask_enableAllInterrupts( );
 *   void           cKernelTask_disableAllInterrupts( );
 *   void           cKernelTask_resumeAllInterrupts( );
 *   void           cKernelTask_suspendAllInterrupts( );
 *   void           cKernelTask_resumeOsInterrupts( );
 *   void           cKernelTask_suspendOsinterrupts( );
 *   AppModeType    cKernelTask_getActiveApplicationMode( );
 *   void           cKernelTask_shutdownOs( StatusType ercd );
 * call port : cKernelISR2  signature: sKernelISR2 context: task
 *   void           cKernelISR2_enableAllInterrupts( );
 *   void           cKernelISR2_disableAllInterrupts( );
 *   void           cKernelISR2_resumeAllInterrupts( );
 *   void           cKernelISR2_suspendAllInterrupts( );
 *   void           cKernelISR2_resumeOsInterrupts( );
 *   void           cKernelISR2_suspendOsinterrupts( );
 *   AppModeType    cKernelISR2_getActiveApplicationMode( );
 *   void           cKernelISR2_shutdownOs( StatusType ercd );
 * call port : cHwSysTimer  signature: sHwSysTimer context: task
 *   void           cHwSysTimer_initialize( );
 *   void           cHwSysTimer_terminate( );
 * call port : cinHwSysTimer  signature: sinHwSysTimer context: task
 *   void           cinHwSysTimer_clearInterrupt( );
 * call port : cCounter  signature: sCounter context: task
 *   StatusType     cCounter_signal( );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tSysTimer_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSysTimer
 * entry port: eSysTimer
 * signature:  sSysTimer
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSysTimer_initialize
 * name:         eSysTimer_initialize
 * global_name:  tSysTimer_eSysTimer_initialize
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSysTimer_initialize()
{
	/*
	 *  ˑNs
	 *  ݋֎~ԂŌďoƁD
	 */
	cHwSysTimer_initialize();
}

/* #[<ENTRY_FUNC>]# eSysTimer_terminate
 * name:         eSysTimer_terminate
 * global_name:  tSysTimer_eSysTimer_terminate
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSysTimer_terminate()
{
	/*
	 *  ˑ~s
	 *  ݋֎~ԂŌďoƁD
	 */
	cHwSysTimer_terminate();
}

/* #[<ENTRY_PORT>]# eHandlerBody
 * entry port: eHandlerBody
 * signature:  sHandlerBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eHandlerBody_main
 * name:         eHandlerBody_main
 * global_name:  tSysTimer_eHandlerBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eHandlerBody_main()
{
	StatusType ercd;

	/*
	 *  ݗvtONA
	 */
	cinHwSysTimer_clearInterrupt();

	/*
	 *  JE^Zʒms
	 */
	ercd = cCounter_signal();

	/* G[^[̏ꍇ	*/
	if( ercd != E_OK ){
		/*  ShutdownOS R[悤ɉCĂ悢 */
	}
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/

