/*
 *  kernel_cfg.c
 *  Mon Jul 09 03:05:33 2012
 *  SG Version 2.10
 *  sg.exe gen\tecsgen.oil -template=..\..\..\config\m16c-renesas\oaks16_mini\m16c26.sgt -I. -I..\..\..\sg\impl_oil -I..\..\..\syslib -I..\..\..\syslib\m16c-renesas\oaks16_mini -os=ECC2
 */
#include "osek_kernel.h"
#include "kernel_id.h"
#include "alarm.h"
#include "interrupt.h"
#include "resource.h"
#include "task.h"

#define __STK_UNIT VP
#define __TCOUNT_STK_UNIT(sz) (((sz) + sizeof(__STK_UNIT) - 1) / sizeof(__STK_UNIT))

#define TNUM_ALARM     1
#define TNUM_COUNTER   1
#define TNUM_ISR2      1
#define TNUM_RESOURCE  1
#define TNUM_TASK      1
#define TNUM_EXTTASK   1

const UINT8 tnum_alarm    = TNUM_ALARM;
const UINT8 tnum_counter  = TNUM_COUNTER;
const UINT8 tnum_isr2     = TNUM_ISR2;
const UINT8 tnum_resource = TNUM_RESOURCE;
const UINT8 tnum_task     = TNUM_TASK;
const UINT8 tnum_exttask  = TNUM_EXTTASK;

 /****** Object OS ******/

 /****** Object TASK ******/

const TaskType MainTask = 0;

extern void TASKNAME( MainTask )( void );

static __STK_UNIT _stack_MainTask[__TCOUNT_STK_UNIT(1024)];

const Priority tinib_inipri[TNUM_TASK] = { TPRI_MINTASK + 6, };
const Priority tinib_exepri[TNUM_TASK] = { TPRI_MINTASK + 6, };
const UINT8 tinib_maxact[TNUM_TASK] = { (1) - 1, };
const AppModeType tinib_autoact[TNUM_TASK] = { 0x00000000, };
const FP tinib_task[TNUM_TASK] = { TASKNAME( MainTask ), };
const __STK_UNIT tinib_stk[TNUM_TASK] = { (__STK_UNIT)_stack_MainTask, };
const UINT16 tinib_stksz[TNUM_TASK] = { 1024, };

UINT8 tcb_tstat[TNUM_TASK];
Priority tcb_curpri[TNUM_TASK];
DEFINE_CTXB(TNUM_TASK);
TaskType tcb_next[TNUM_TASK];
EventMaskType tcb_curevt[TNUM_EXTTASK];
EventMaskType tcb_waievt[TNUM_EXTTASK];
UINT8 tcb_actcnt[TNUM_TASK];
ResourceType tcb_lastres[TNUM_TASK];

 /****** Object COUNTER ******/

const CounterType SysTimerCnt = 0;

const TickType cntinib_maxval[TNUM_COUNTER] = { 999, };
const TickType cntinib_maxval2[TNUM_COUNTER] = { 1999, };
const TickType cntinib_tickbase[TNUM_COUNTER] = { 1, };
const TickType cntinib_mincyc[TNUM_COUNTER] = { 1, };

AlarmType cntcb_almque[TNUM_COUNTER];
TickType cntcb_curval[TNUM_COUNTER];

 /****** Object ALARM ******/

const AlarmType MainCycleAlarm = 0;

DeclareTask(MainTask);
static void _activate_alarm_MainCycleAlarm( void );
static void _activate_alarm_MainCycleAlarm( void )
{ (void)ActivateTask( MainTask ); }

const CounterType alminib_cntid[TNUM_ALARM] = { 0, };
const FP alminib_cback[TNUM_ALARM] = { _activate_alarm_MainCycleAlarm, };
const AppModeType alminib_autosta[TNUM_ALARM] = { 0x00000001, };
const TickType alminib_almval[TNUM_ALARM] = { 50, };
const TickType alminib_cycle[TNUM_ALARM] = { 50, };

AlarmType almcb_next[TNUM_ALARM];
AlarmType almcb_prev[TNUM_ALARM];
TickType almcb_almval[TNUM_ALARM];
TickType almcb_cycle[TNUM_ALARM];

 /****** Object RESOURCE ******/

const ResourceType Resource1 = 0;

const Priority resinib_ceilpri[TNUM_RESOURCE] = { TPRI_MINISR + 4, };

Priority rescb_prevpri[TNUM_RESOURCE];
ResourceType rescb_prevres[TNUM_RESOURCE];

 /****** Object EVENT ******/

const EventMaskType Event1 = (1UL << 0);
const EventMaskType Event2 = (1UL << 1);

 /****** Object ISR ******/

const IsrType SysTimerInt = 0;

#define IPL_MAXISR2 4
const IPL ipl_maxisr2 = IPL_MAXISR2;


const Priority isrinib_intpri[TNUM_ISR2] = { TPRI_MINISR + (4), };
ResourceType isrcb_lastres[TNUM_ISR2];

 /****** Object APPMODE ******/

void object_initialize( void )
{
	alarm_initialize();
	interrupt_initialize();
	resource_initialize();
	task_initialize();
}

/*
 *  TOPPERS Automotive Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel
 * 
 *  Copyright (C) 2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */







/* ݓOQ */
ISR1_EXTERNAL(RxHwSerialInt);
ISR2_EXTERNAL(SysTimerInt);


/* ݓ	*/
ISR1_ENTRY(RxHwSerialInt);
ISR2_ENTRY(SysTimerInt,(0));


/* xN^e[uo^V{OQ	*/
UNUSED_INT_EXTERNAL();		/* `̊							*/
asm("	.glb	_start");	/* Zbg									*/

/* ݉σxN^e[u	*/
asm("	.section vvector");

UNUSED_INT_SYMBOL();			/*  0, +0x00: BRK				*/
UNUSED_INT_SYMBOL();			/*  1, +0x04: \̈				*/
UNUSED_INT_SYMBOL();			/*  2, +0x08: \̈				*/
UNUSED_INT_SYMBOL();			/*  3, +0x0C: \̈				*/
UNUSED_INT_SYMBOL();			/*  4, +0x10: O3			*/
UNUSED_INT_SYMBOL();			/*  5, +0x14: \̈				*/
UNUSED_INT_SYMBOL();			/*  6, +0x18: \̈				*/
UNUSED_INT_SYMBOL();			/*  7, +0x1C: \̈				*/
UNUSED_INT_SYMBOL();			/*  8, +0x20: O5			*/
UNUSED_INT_SYMBOL();			/*  9, +0x24: O4			*/
UNUSED_INT_SYMBOL();		/* 10, +0x28: UART2oXՓˌo		*/
UNUSED_INT_SYMBOL();		/* 11, +0x2C: DMA0					*/
UNUSED_INT_SYMBOL();		/* 12, +0x30: DMA1					*/
UNUSED_INT_SYMBOL();		/* 13, +0x34: L[͊		*/
UNUSED_INT_SYMBOL();		/* 14, +0x38: A/Dϊ				*/
UNUSED_INT_SYMBOL();		/* 15, +0x3C: UART2M NACK2		*/
UNUSED_INT_SYMBOL();		/* 16, +0x40: UART2M ACK2		*/
UNUSED_INT_SYMBOL();		/* 17, +0x44: UART0M				*/
UNUSED_INT_SYMBOL();		/* 18, +0x48: UART0M				*/
UNUSED_INT_SYMBOL();		/* 19, +0x4C: UART1M				*/
ISR1_SYMBOL(RxHwSerialInt);		/* 20, +0x50: UART1M				*/
ISR2_SYMBOL(SysTimerInt);		/* 21, +0x54: ^C}A0				*/
UNUSED_INT_SYMBOL();		/* 22, +0x58: ^C}A1				*/
UNUSED_INT_SYMBOL();		/* 23, +0x5C: ^C}A2				*/
UNUSED_INT_SYMBOL();		/* 24, +0x60: ^C}A3				*/
UNUSED_INT_SYMBOL();		/* 25, +0x64: ^C}A4				*/
UNUSED_INT_SYMBOL();		/* 26, +0x68: ^C}B0				*/
UNUSED_INT_SYMBOL();		/* 27, +0x6C: ^C}B1				*/
UNUSED_INT_SYMBOL();		/* 28, +0x70: ^C}B2				*/
UNUSED_INT_SYMBOL();		/* 29, +0x74: O0			*/
UNUSED_INT_SYMBOL();		/* 30, +0x78: O1			*/
UNUSED_INT_SYMBOL();		/* 31, +0x7C: \̈				*/
UNUSED_INT_SYMBOL();		/* 32, +0x80: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 33, +0x84: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 34, +0x88: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 35, +0x8C: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 36, +0x90: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 37, +0x94: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 38, +0x98: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 39, +0x9C: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 40, +0xA0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 41, +0xA4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 42, +0xA8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 43, +0xAC: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 44, +0xB0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 45, +0xB4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 46, +0xB8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 47, +0xBC: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 48, +0xC0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 49, +0xC4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 50, +0xC8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 51, +0xCC: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 52, +0xD0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 53, +0xD4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 54, +0xD4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 55, +0xDC: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 56, +0xE0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 57, +0xE8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 58, +0xE8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 59, +0xEC: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 60, +0xF0: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 61, +0xF4: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 62, +0xF8: \tgEFA	*/
UNUSED_INT_SYMBOL();		/* 63, +0xFC: \tgEFA	*/

/* ݌ŒxN^e[u	*/
asm("	.section fvector");

UNUSED_INT_SYMBOL();		/* 64, 0xFFFFDC: `					*/
UNUSED_INT_SYMBOL();		/* 65, 0xFFFFE0: I[o[t[				*/
UNUSED_INT_SYMBOL();		/* 66, 0xFFFFE4: BRK					*/
UNUSED_INT_SYMBOL();		/* 67, 0xFFFFE8: AhXv				*/
UNUSED_INT_SYMBOL();		/* 68, 0xFFFFEC: \̈(VOXebv)	*/
UNUSED_INT_SYMBOL();		/* 69, 0xFFFFF0: Ď^C}/U~o	*/
UNUSED_INT_SYMBOL();		/* 70, 0xFFFFF4: \̈(DBC)				*/
UNUSED_INT_SYMBOL();		/* 71, 0xFFFFF8: NMI						*/
asm("	.lword	_start");/* 72, 0xFFFFFC: Zbg					*/

/* tbN[`	*/
NULL_ERRORHOOK

NULL_SHUTDOWNHOOK
NULL_PRETASKHOOK
NULL_POSTTASKHOOK



